VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cListviewEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

'tool tip
'''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetScrollBarInfo Lib "user32" (ByVal Hwnd As Long, ByVal idObject As Long, psbi As SCROLLBARINFO) As Long
Private Declare Function GetScrollInfo Lib "user32" (ByVal Hwnd As Long, ByVal n As Long, lpScrollInfo As SCROLLINFO) As Long
Private Declare Function SetScrollInfo Lib "user32" (ByVal Hwnd As Long, ByVal n As Long, lpcScrollInfo As SCROLLINFO, ByVal bool As Boolean) As Long
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)
Private Declare Function GetClientRect Lib "user32" (ByVal Hwnd As Long, lpRect As RECT) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long


'Constantes y UDT
''''''''''''''''''''''''''''''''''

Private Const WM_USER = &H400
Private Const CW_USEDEFAULT = &H80000000

Private Const TTS_NOPREFIX = &H2
Private Const TTF_TRANSPARENT = &H100
Private Const TTF_CENTERTIP = &H2
Private Const TTM_ADDTOOLA = (WM_USER + 4)
Private Const TTM_ACTIVATE = WM_USER + 1
Private Const TTM_UPDATETIPTEXTA = (WM_USER + 12)
Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_SETTITLE = (WM_USER + 32)
Private Const TTS_BALLOON = &H40
Private Const TTS_ALWAYSTIP = &H1
Private Const TTF_SUBCLASS = &H10
Private Const TTF_IDISHWND = &H1
Private Const TTM_SETDELAYTIME = (WM_USER + 3)
Private Const TTDT_AUTOPOP = 2
Private Const TTDT_INITIAL = 3
Private Const TOOLTIPS_CLASSA = "tooltips_class32"

Private Const SB_VERT = 1
Private Const SIF_RANGE = &H1
Private Const SIF_PAGE = &H2
Private Const SIF_POS = &H4
Private Const SIF_ALL = (SIF_RANGE Or SIF_PAGE Or SIF_POS)
Private Const OBJID_VSCROLL = &HFFFFFFFB
Private Const WM_VSCROLL = &H115
Private Const SB_BOTTOM = 7
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_GETITEMCOUNT As Long = (LVM_FIRST + 4)
Private Const LVM_GETITEMTEXTA As Long = (LVM_FIRST + 45)
Private Const LVM_GETSUBITEMRECT As Long = (LVM_FIRST + 56)
Private Const LVM_GETVIEWRECT As Long = (LVM_FIRST + 34)
Private Const LVM_GETWORKAREAS As Long = (LVM_FIRST + 70)
Private Const LVM_GETTOPINDEX As Long = (LVM_FIRST + 39)
Private Const LVM_GETHEADER  As Long = (LVM_FIRST + 31)
Private Const LVM_GETCOLUMN = (LVM_FIRST + 25)

Private Const LVCF_TEXT As Long = &H4
Private Const LVCF_ORDER As Long = &H20
Private Const LVCF_FMT As Long = &H1
Private Const LVCF_IMAGE As Long = &H10

Private Const LVIF_TEXT = &H1
Private Const LVIR_LABEL = 2

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type SCROLLINFO
    cbSize As Long
    fMask As Long
    nMin As Long
    nMax As Long
    nPage As Long
    nPos As Long
    nTrackPos As Long
End Type

Private Type SCROLLBARINFO
    cbSize As Long
    rcScrollBar As RECT
    dxyLineButton As Long
    xyThumbTop As Long
    xyThumbBottom As Long
    reserved As Long
    rgstate(0 To 5) As Long
End Type

Private Type TOOLINFO
    lSize As Long
    lFlags As Long
    Hwnd As Long
    lId As Long
    lpRect As RECT
    hInstance As Long
    lpStr As String
    lParam As Long
End Type


Private Type LV_ITEM
    mask As Long
    iItem As Long
    iSubItem As Long
    State As Long
    stateMask As Long
    pszText As Long
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type HDHITTESTINFO
    pt As POINTAPI
    flags As Long
    iItem As Long
End Type



Private Type LVHITTESTINFO
    pt As POINTAPI
    lFlags As Long
    lItem As Long
    lSubItem As Long
End Type


' styles for listview
Private Const LVS_EX_GRIDLINES = &H1
Private Const LVS_EX_FULLROWSELECT = &H20

Private Const LVM_GETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + &H37
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + &H36
Private Const LVM_SUBITEMHITTEST = (LVM_FIRST + 57)

' hittest constants
Private Const LVHT_NOWHERE = &H1
Private Const LVHT_ONITEMICON = &H2
Private Const LVHT_ONITEMLABEL = &H4
Private Const LVHT_ONITEMSTATEICON = &H8
Private Const LVHT_ONITEM = (LVHT_ONITEMICON Or LVHT_ONITEMLABEL Or LVHT_ONITEMSTATEICON)

' edit subitem constants
Private Const LVIR_BOUNDS = 0
Private Const LVIR_ICON = 1
Private Const LVIR_SELECTBOUNDS = 3

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private WithEvents mListView As ListView
Attribute mListView.VB_VarHelpID = -1
Private WithEvents mtextBox  As textBox
Attribute mtextBox.VB_VarHelpID = -1

Private mvarBackColor As Long
Private mvarTitle As String
Private mvarForeColor As Long
Private mvarIcon As ttIconType
Private mvarCentered As Boolean
Private mvarStyle As ttStyleEnum
Private mvarTipText As String
Private mvarVisibleTime As Long
Private mvarDelayTime As Long


Private m_lTTHwnd As Long
Private m_lParentHwnd As Long
Private ti As TOOLINFO

Private mParentlv As Long
Private mContainerlv As Long
Private tHt As LVHITTESTINFO

Private sNametxt As String
Private lhWnd As Long

Public Event BeforeEdit(ByVal Columna As Integer, Cancel As Boolean, lvItem As Variant)
Public Event AfterEdit(ByVal Columna As Integer, Cancel As Boolean, Value As Variant, lvItem As Variant)
Public Event KeyPress(ByVal Columna As Integer, Cancel As Boolean, KeyAscii As Integer)
Public Event Change(ByVal Columna As Integer, Value As Variant)



Public Function SowToolTipText( _
    Title As String, _
    TipText As String, _
    Optional Icon As ttIconType = TTIconInfo, _
    Optional Style As ttStyleEnum = TTBalloon, _
    Optional Centered As Boolean = False, _
    Optional ForeColor = vbBlack, _
    Optional BackColor = &HC0FFFF, _
    Optional VisibleTime As Long = 5000, _
    Optional DelayTime As Long = 0) As Boolean
   
   
   
   If mListView Is Nothing Then Exit Function
   
   mvarTitle = Title
   mvarStyle = Style
   mvarIcon = Icon
   mvarForeColor = ForeColor
   mvarBackColor = BackColor
   mvarTipText = TipText
   mvarVisibleTime = VisibleTime
   mvarDelayTime = DelayTime
   
   If m_lTTHwnd <> 0 Then
      DestroyWindow m_lTTHwnd
   End If
   
   m_lParentHwnd = mListView.Hwnd
   
   Dim lWinStyle As Long
   lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX
   If mvarStyle = TTBalloon Then lWinStyle = lWinStyle Or TTS_BALLOON
   
   Dim lxSubItem As Long
   Dim lySubItem As Long
    
   Dim recClientLv As RECT
    
   GetWindowRect m_lParentHwnd, recClientLv
    
   lxSubItem = (tHt.pt.x + recClientLv.Left)
   lySubItem = (tHt.pt.y + recClientLv.Top)
    
   SetCursorPos lxSubItem, lySubItem
    
   m_lTTHwnd = CreateWindowEx(0&, _
      TOOLTIPS_CLASSA, _
      vbNullString, _
      lWinStyle, _
      CW_USEDEFAULT, _
      CW_USEDEFAULT, _
      CW_USEDEFAULT, _
      CW_USEDEFAULT, _
      0&, _
      0&, _
      App.hInstance, _
      0&)
               
   With ti
   
      If mvarCentered Then
         .lFlags = TTF_SUBCLASS Or TTF_CENTERTIP Or TTF_IDISHWND
      Else
         .lFlags = TTF_SUBCLASS Or TTF_IDISHWND
      End If
       
      .Hwnd = m_lParentHwnd
      .lId = m_lParentHwnd ' m_lParentHwnd '0
      .hInstance = App.hInstance
      .lSize = Len(ti)
      '.lpRect.Left = 100
      '.lpRect.Top = 10
   End With
   
   If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
      SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
   End If
   
   If m_lTTHwnd <> 0 Then
      SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
   End If
   
   If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
      SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
   End If

   
   ti.lpStr = mvarTipText
   If m_lTTHwnd <> 0 Then
      SendMessage m_lTTHwnd, TTM_UPDATETIPTEXTA, 0&, ti
   End If
   

   SendMessage m_lTTHwnd, TTM_ADDTOOLA, 0&, ti

   
   If mvarTitle <> vbNullString Or mvarIcon <> TTNoIcon Then
      SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
   End If

   If mvarForeColor <> Empty Then
      SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
   End If

   If mvarBackColor <> Empty Then
      SendMessage m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
   End If
   
   SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, mvarVisibleTime
   SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, mvarDelayTime
End Function

Public Sub Destroy()
   If m_lTTHwnd <> 0 Then
      DestroyWindow m_lTTHwnd
   End If
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


' para la versin 5
Private Sub ListView_FullRowSelect(ByRef ListView As ListView)

    Dim lStyle As Long
    lStyle = SendMessage(ListView.Hwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)
    lStyle = lStyle Or LVS_EX_FULLROWSELECT
    Call SendMessage(ListView.Hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, ByVal lStyle)

End Sub
' para la versin 5
Private Sub ListView_GridLines(ByRef ListView As ListView)
    
    Dim lStyle As Long
    lStyle = SendMessage(ListView.Hwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)
    lStyle = lStyle Or LVS_EX_GRIDLINES
    Call SendMessage(ListView.Hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, ByVal lStyle)

End Sub

Private Function ListView_ReturnSelected(ListView As ListView) As ListItem

    Set ListView_ReturnSelected = Nothing
    
    Dim lvCount As Integer
    lvCount = ListView.ListItems.Count
    
    If lvCount = 0 Then Exit Function
        
    Dim lvIndex As Integer
    For lvIndex = 1 To lvCount
        If ListView.ListItems(lvIndex).Selected = True Then
            Set ListView_ReturnSelected = ListView.ListItems(lvIndex)
            Exit Function
        End If
    Next lvIndex
        
End Function

Private Function ListView_HitTest(ListView As ListView, x As Single, y As Single) As LVHITTESTINFO
    Dim lRet As Long
    Dim lX As Long
    Dim lY As Long

    'x and y are in twips; convert them to pixels for the API call
    lX = x / Screen.TwipsPerPixelX
    lY = y / Screen.TwipsPerPixelY

    Dim tHitTest As LVHITTESTINFO
    
    With tHitTest
        .lFlags = 0
        .lItem = 0
        .lSubItem = 0
        .pt.x = lX
        .pt.y = lY
    End With
    
    'return the filled Structure to the routine
    lRet = SendMessage(ListView.Hwnd, LVM_SUBITEMHITTEST, 0, tHitTest)
    
    ListView_HitTest = tHitTest
    
End Function

Private Sub ListView_ScaleEdit()

    If tHt.lItem = -1 Then
        mtextBox.Visible = False
        Exit Sub
    End If
        
    Dim old_Scale As Integer
    Dim frm As Form
    Set frm = mListView.Parent
    
    old_Scale = frm.ScaleMode
    frm.ScaleMode = vbTwips
            
    Dim XPixels As Integer
    Dim YPixels As Integer
    
    XPixels = Screen.TwipsPerPixelX
    YPixels = Screen.TwipsPerPixelY
    
    Dim tRec As RECT
    
    With tRec
        .Top = tHt.lSubItem
        .Left = LVIR_LABEL
        .Bottom = 0
        .Right = 0
    End With
    
    Dim lRet As Long
    lRet = SendMessage(mListView.Hwnd, LVM_GETSUBITEMRECT, tHt.lItem, tRec)
    
        
    Dim lvRect As RECT
    lRet = GetClientRect(mListView.Hwnd, lvRect)
    
    With lvRect
        .Bottom = .Bottom * YPixels
        .Right = .Right * XPixels
        .Top = Round((mListView.Top - .Right) / 2)
        .Left = Round((mListView.Height - .Bottom) / 2)
    End With
    
    Dim lDifTop As Long
    Dim lDifLeft As Long
      
    lDifLeft = 50
    lDifTop = 50
      
    With mtextBox
        .Top = (mListView.Top + tRec.Top * YPixels) + lDifTop
        .Left = (mListView.Left) + (tRec.Left * XPixels) + lDifLeft
        .Width = ((tRec.Right - tRec.Left) * XPixels) - XPixels
        .Height = ((tRec.Bottom - tRec.Top) * YPixels)
        
        If (.Left + .Width) > (mListView.Width + mListView.Left) - GetScrollListViewWidth(mListView.Hwnd) * XPixels Then
           .Width = (mListView.Width + mListView.Left - .Left) - GetScrollListViewWidth(mListView.Hwnd) * XPixels
        End If
        
        If (.Left) < (mListView.Left) Then
           .Width = (.Width - (mListView.Left - .Left)) - (2 * XPixels)
           .Left = mListView.Left + (2 * XPixels)
           
        ElseIf tHt.lSubItem = 0 Then
           .Left = mListView.Left + 50
           .Width = .Width + 25
           
        End If
        .ZOrder 0
    End With
    
    Call ListView_BeforeEdit
    frm.ScaleMode = old_Scale
    
End Sub
Function SetPropertyTextBoxEdit( _
    Optional pBackColor As Long = vbWhite, _
    Optional pForeColor As Long = vbBlack)
    
    If Not mtextBox Is Nothing Then
        mtextBox.BackColor = pBackColor
        mtextBox.ForeColor = pForeColor
    End If
End Function

Public Function GetScrollListViewWidth(Hwnd As Long) As Long

Dim SI As SCROLLINFO
Dim scrlBarINF As SCROLLBARINFO


SI.cbSize = Len(SI)
SI.fMask = SIF_PAGE


Call GetScrollInfo(Hwnd, ByVal SB_VERT, SI)

If SendMessage(Hwnd, LVM_GETITEMCOUNT, 0, 0) > SI.nPage Then 'el scroll esta visible
    scrlBarINF.cbSize = Len(scrlBarINF)
    GetScrollBarInfo Hwnd, OBJID_VSCROLL, scrlBarINF
    GetScrollListViewWidth = scrlBarINF.rcScrollBar.Right - scrlBarINF.rcScrollBar.Left 'el ancho del scroll del sitema
    Call ZeroMemory(scrlBarINF, Len(scrlBarINF))
End If
Call ZeroMemory(SI, Len(SI))
End Function

Private Sub ListView_BeforeEdit()

    If tHt.lItem = -1 Then
        Exit Sub
    End If

    If tHt.lSubItem = 0 Then
        mtextBox.Text = mListView.ListItems(tHt.lItem + 1).Text
    Else
        mtextBox.Text = mListView.ListItems(tHt.lItem + 1).SubItems(tHt.lSubItem)
    End If
    
    With mtextBox
        .Visible = True
        .SetFocus
        If Len(.Text) > 0 Then
            .SelStart = 0
            .SelLength = Len(.Text)
            .Tag = .Text
        End If
    End With
End Sub

Private Sub ListView_AfterEdit()

    Dim bEditMode As Boolean
    bEditMode = False
    
    If tHt.lItem > -1 Then
        If mtextBox.Visible = True Then
            bEditMode = True
        End If
    End If
    
    If bEditMode = True Then
       
       ' para no notificar el change en caso de que el valor no haya cambiado
       If Trim(mtextBox.Tag) <> LCase(mtextBox.Text) Then
          Dim Cancel As Boolean ' valor por referencia para cancelar
          If (tHt.lItem + 1) <= mListView.ListItems.Count Then
            RaiseEvent AfterEdit(tHt.lSubItem, Cancel, mtextBox.Text, mListView.ListItems(tHt.lItem + 1))
          Else
            Exit Sub
          End If
       End If
       
       If Cancel = False Then
          If tHt.lSubItem = 0 Then
             mListView.ListItems(tHt.lItem + 1).Text = mtextBox.Text
          Else
             mListView.ListItems(tHt.lItem + 1).SubItems(tHt.lSubItem) = mtextBox.Text
          End If
          tHt.lSubItem = (tHt.lSubItem + 1) Mod mListView.ColumnHeaders.Count
          
          If tHt.lSubItem = 0 Then
             tHt.lItem = (tHt.lItem + 1) Mod mListView.ListItems.Count
          End If
      End If
   End If
    
   With mtextBox
     .Visible = False
   End With
End Sub

Private Sub Class_Initialize()
    

    InitCommonControls
    mvarDelayTime = 0
    mvarVisibleTime = 5000
End Sub

Sub init(ListView As ListView)
    
    Set mListView = ListView
    
    Set mListView = ListView
    With mListView
    
       .FullRowSelect = True
       .HotTracking = False
       .BorderStyle = ccNone
       .Appearance = cc3D
       .FlatScrollBar = False
    End With
    
    Dim frm As Form
    Set frm = ListView.Parent
    mParentlv = ListView.Parent.Hwnd
    
    Dim i As Integer
       On Error Resume Next
       Do
        Err.Clear
        sNametxt = "txtEdit" & CStr(i)
        Set mtextBox = frm.Controls.Add("vb.TextBox", sNametxt)
        i = i + 1
    Loop Until Err.Number = 0
    
    Err.Clear
    
    With mtextBox
       .Appearance = ccFlat
       .BorderStyle = 0
       .BackColor = vbWhite
       Set .Container = ListView.Container
       .ZOrder 0

       Set .Font = mListView.Font
    End With
    
    lhWnd = mListView.Hwnd
    
End Sub

Private Sub Class_Terminate()
    Set mListView = Nothing
    Set mtextBox = Nothing
    Call Destroy
End Sub

Private Sub mtextBox_Change()
    If tHt.lSubItem <> -1 Then
        RaiseEvent Change(tHt.lSubItem, mtextBox.Text)
    End If
End Sub

Private Sub mtextBox_KeyPress(KeyAscii As Integer)

    If KeyAscii = vbKeyEscape Then
       mtextBox.Visible = False
    ElseIf KeyAscii = vbKeyReturn Then
       Call ListView_AfterEdit
    ElseIf tHt.lSubItem <> -1 And KeyAscii <> 8 Then
        Dim Cancel  As Boolean
        
        RaiseEvent KeyPress(tHt.lSubItem, Cancel, KeyAscii)
        
        If Cancel = True Then
           KeyAscii = 0
        End If
    End If
        
End Sub

Private Sub mtextBox_LostFocus()
    
    Call ListView_AfterEdit
    
    If mtextBox.Visible = True Then
       mtextBox.Visible = False
    End If

End Sub

Private Sub mListView_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Me.Destroy
    Call ListView_AfterEdit
      
    tHt = ListView_HitTest(mListView, x, y)
End Sub

Private Sub mListview_DblClick()
    
    Dim iCol As Integer
    Dim Cancel As Boolean
    iCol = tHt.lSubItem
    If tHt.lItem + 1 > mListView.ListItems.Count Or tHt.lItem = -1 Then Exit Sub
    RaiseEvent BeforeEdit(iCol, Cancel, mListView.ListItems(tHt.lItem + 1))
    If Not Cancel Then
        Call ListView_ScaleEdit
    End If

End Sub




